local druid = require "druid.druid"
local component = require "druid.component"
local richtext = require "richtext.richtext"

local M = component.create("richtext")

function M.set_items(self, items)
	self.list_data:set_data(items)
end

local function create_function(self, data, index, data_list)
	-- In data list create funtion we made all init stuff for this node
	local instance = gui.clone_tree(self.inv_prefab)
	local root = instance["inv_prefab"]
	gui.set_enabled(root, true)

	-- local label = self.druid:new_text(instance["label"], "", true)
	-- label.words = {}
	-- local settings = table.copy(font_settings)
	-- settings["parent"] = label.node
	-- local words, metrics = richtext.create(characters.replace(data.prompt), "kanji", settings)
	-- for _,word in pairs(words) do
	-- 	table.insert(label.words, word)
	-- 	local p = gui.get_position(word.node)
	-- 	gui.set_position(word.node, vmath.vector3(p.x+8, p.y + 20, p.z))
	-- end
	
	-- local subtitle = self.druid:new_text(instance["sublabel"], data.answer, true)
	-- local duelabel = self.druid:new_text(instance["duelabel"], duestring(data), true)
	
	-- We should return in this function root node and optionally - Druid component
	return root
end

local function show_inventory(self, items)
	print("show inv")
	gui.set_enabled(self.box, true)

	M.set_items(self, items)

	gui.set_scale(self.box, vmath.vector3(1, 0, 1))
	gui.animate(self.box, gui.PROP_SCALE, vmath.vector3(1, 1, 1), gui.EASING_OUTSINE, 0.33, 0, function()

	end)
end

local function hide_inventory(self)
	gui.animate(self.box, gui.PROP_SCALE, vmath.vector3(1, 0, 1), gui.EASING_OUTSINE, 0.33, 0, function()
		gui.set_enabled(self.box, false)
	end)
end

-----

function M.toggle_inventory(self, items)
	print("show inv")
	if gui.is_enabled(self.box) then
		hide_inventory(self)
	else
		show_inventory(self, items)
	end
end


------

-- Component constructor
function M.init(self, node, value, font, settings)
	self.druid = self:get_druid()
	self.box = self:get_node(node)

	self.inv_prefab = gui.get_node("inv_prefab")
	gui.set_enabled(self.inv_prefab, false)
	
	local scroll = self.druid:new_scroll("list_view", "list_view_content")
	scroll:set_horizontal_scroll(false)
	scroll.style["WHEEL_SCROLL_SPEED"] = 10
	scroll.style["WHEEL_SCROLL_INVERTED"] = true
	self.item_grid = self.druid:new_static_grid("list_view_content", "inv_prefab", 4)

	self.list_data = self.druid:new_data_list(scroll, self.item_grid, create_function)

	gui.set_enabled(self.box, false)
end

-- Call only if exist interest: component.ON_UPDATE
function M.update(self, dt)
end

-- Call only if exist interest: component.ON_INPUT or component.ON_INPUT_HIGH
function M.on_input(self, action_id, action)
end

-- Call on component creation and on component:set_style() function
function M.on_style_change(self, style)
end

-- Call only if exist interest: component.ON_MESSAGE
function M.on_message(self, message_id, message, sender)
end

-- Call only if component with ON_LAYOUT_CHANGE interest
function M.on_layout_change(self)
end

-- Call, if input was capturing before this component
-- Example: scroll is start scrolling, so you need unhover button
function M.on_input_interrupt(self)
end

-- Call, if game lost focus. Need ON_FOCUS_LOST intereset
function M.on_focus_lost(self)
end

-- Call, if game gained focus. Need ON_FOCUS_GAINED intereset
function M.on_focus_gained(self)
end

-- Call on component remove or on druid:final
function M.on_remove(self)
end

return M