local component = require "druid.component"
local richtext = require "richtext.richtext"

local M = component.create("richtext")

-- Component constructor
function M.init(self, node, value, font, settings)
	local line_height = gui.get_size(node).y
	gui.set_text(node, "")
	settings["parent"] = node
	self.words, self.metrics = richtext.create(value, font, settings)
	for _,word in pairs(self.words) do
		local p = gui.get_position(word.node)
		gui.set_position(word.node, vmath.vector3(p.x, 0, p.z))
	end
end

-- Call only if exist interest: component.ON_UPDATE
function M.update(self, dt)
end

-- Call only if exist interest: component.ON_INPUT or component.ON_INPUT_HIGH
function M.on_input(self, action_id, action)
end

-- Call on component creation and on component:set_style() function
function M.on_style_change(self, style)
end

-- Call only if exist interest: component.ON_MESSAGE
function M.on_message(self, message_id, message, sender)
end

-- Call only if component with ON_LAYOUT_CHANGE interest
function M.on_layout_change(self)
end

-- Call, if input was capturing before this component
-- Example: scroll is start scrolling, so you need unhover button
function M.on_input_interrupt(self)
end

-- Call, if game lost focus. Need ON_FOCUS_LOST intereset
function M.on_focus_lost(self)
end

-- Call, if game gained focus. Need ON_FOCUS_GAINED intereset
function M.on_focus_gained(self)
end

-- Call on component remove or on druid:final
function M.on_remove(self)
	richtext.remove(self.words)
end

return M